package art.soft;

import java.io.File;
import java.io.IOException;
import java.io.RandomAccessFile;

/**
 *
 * @author Артём Святоха
 */
public class DiskDriver {

    private final static IOException DISK_NOT_FOUND = new IOException();
    private RandomAccessFile disk = null;

    public boolean isInsert() {
        return disk != null;
    }

    public void insert(File file) throws IOException {
        if (disk != null) disk.close();
        disk = new RandomAccessFile(file, "rw");
    }

    public int read(byte[] buf, int offs, int filePos, int count) throws IOException {
        if (disk == null) throw DISK_NOT_FOUND;
        disk.seek(filePos);
        return disk.read(buf, offs, count);
    }

    public int write(byte[] buf, int offs, int filePos, int count) throws IOException {
        if (disk == null) throw DISK_NOT_FOUND;
        disk.seek(filePos);
        disk.write(buf, offs, count);
        return count;
    }

    public int getSize() throws IOException {
        if (disk == null) throw DISK_NOT_FOUND;
        return (int) disk.length();
    }

    public void close() throws IOException {
        if (disk != null) {
            disk.close();
            disk = null;
        }
    }
}
